=== debian/changelog ===
bareos (25.0.0~pre1122.67d34e6f8-3) unstable; urgency=low

  * See https://docs.bareos.org/release-notes/

 -- Bareos Jenkins <noreply@bareos.com>  Tue, 18 Nov 2025 10:53:48 +0000
