## bareos 25.0.0~pre1140.03031eeeb

=== debian/changelog ===
bareos (25.0.0~pre1140.03031eeeb-2193) unstable; urgency=low

  * See https://docs.bareos.org/release-notes/

 -- Bareos Jenkins <noreply@bareos.com>  Thu, 20 Nov 2025 14:05:40 +0000
