## bareos 25.0.0~pre1173.5a9dbe4e3

=== debian/changelog ===
bareos (25.0.0~pre1173.5a9dbe4e3-8) unstable; urgency=low

  * See https://docs.bareos.org/release-notes/

 -- Bareos Jenkins <noreply@bareos.com>  Tue, 25 Nov 2025 18:21:35 +0000
