## bareos 25.0.0~pre1173.cb7454c95

=== debian/changelog ===
bareos (25.0.0~pre1173.cb7454c95-9) unstable; urgency=low

  * See https://docs.bareos.org/release-notes/

 -- Bareos Jenkins <noreply@bareos.com>  Wed, 26 Nov 2025 08:59:48 +0000
